package Basic3SV;

import java.util.*;


public class Tri {



  public static void main(String[] args) {
    
  Hashtable h1 = Tri.genTrigramTable("long string long");

  Hashtable h2 = Tri.genTrigramTable("longish string string");

  System.out.println(h1.toString());

  System.out.println(h2.toString());

  double d =  Tri.compareTrigramTables(h1,h2);

  
  System.out.println(d);

  }


  public Tri() {}


public static Hashtable genTrigramTable(String s) {
	Vector v = new Vector();
	Hashtable h = new Hashtable();
	StringTokenizer strtoken = new StringTokenizer(s.toLowerCase()," ,.!;:-/?");
          for(;strtoken.hasMoreElements();) 
            v.addElement(strtoken.nextToken());

	// generate trigrams and add to h
	for(int i=0;i<v.size();i++)
	   createTrigrams((String)v.elementAt(i),h);

  return h;
}

public static void createTrigrams(String s, Hashtable h) {
        char[] ca = new char[s.length()];
	ca = s.toCharArray();

	for(int i=0;i+3<ca.length;++i) {
	   String key =String.valueOf(ca,i,3);
	
	    if(h.containsKey(key)) {
	   	Integer k = (Integer)h.remove(key);
	        int l = k.intValue();
	        h.put(key,new Integer(++l));}
	    else {
	        h.put(key,new Integer(1));}	   

	}
  }



public static double compareTrigramTables(Hashtable h1, Hashtable h2) {

   int postivescore = 0;
   int negativescore = 0;
   Enumeration e1 = h1.keys();
   Enumeration e2 = h2.keys();

   for(;e1.hasMoreElements();) {
	String key = (String)e1.nextElement();
	if(h2.containsKey(key)) {
	   Integer k = (Integer)h1.get(key);
	   postivescore += k.intValue();}
	else {
	   Integer k = (Integer)h1.get(key);
	   negativescore += k.intValue();}
   }

  
   for(;e2.hasMoreElements();) {
	String key = (String)e2.nextElement();
	if(h1.containsKey(key)) {
	   Integer k = (Integer)h2.get(key);
	   postivescore += k.intValue();}
	else {
	   Integer k = (Integer)h2.get(key);
	   negativescore += k.intValue();}
   }
   return ((double)  postivescore)/((double) postivescore + negativescore);
}
  
}

