package Basic3SV;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.net.*;


public class TripleViewer {

    Table response;
    static String tstoreloc = "http://triplestore.aktors.org/rdql/?query";
    public static boolean sort = false;
    public static String svar;
    public static String sterm;

    public static int timeout = 10; // time (in secs) to wait...

    static ThreadCondition queryResponse = new ThreadCondition("query-response");

//      static String epsrctopics[] = {"Human-Computer Interactions",
//  			     "Information and Knowledge Management",
//  			     "Intelligent and Expert Systems",
//  			     "Multimedia",
//  			     "Networks and Distributed Systems",
//  			     "Software Engineering",
//  			     "Fundamentals of Computing and AI",
//  			     "User Interface Technologies"};

    // note the order of the following may be important:
    static String epsrctopics[] = {
	"Information and Knowledge Management",
	"Intelligent and Expert Systems",
	"Fundamentals of Computing and AI",
	"Networks and Distributed Systems",
	"Software Engineering",
	"Multimedia",
	"User Interface Technologies",
	"Human-Computer Interactions"
    };
public TripleViewer() {}


//      public String getQuery() {
//  	String r="";
//  	String s = qtext.getText();
//  	StringTokenizer strt = new StringTokenizer(s,"\n");
//          for(;strt.hasMoreElements();) {
//            r=r+(String)(strt.nextToken());
//          }
//  	return r;
//      }
 

//      public static void postQuery_ParseXML(String s) {
//  	final String es;
//  	try{
//  	    es = URLEncoder.encode(s, "UTF-8");

//  	System.out.println("Sent query...waiting for response");
//  	//(new SXML()).callParser("x.xml");


//  	// probably don't want this threaded for prolog calls...
//  	new Thread(){
//  		SXML parser = new SXML();
//  		public void run(){
//  		    //parser.callParserURI("http://triplestore.aktors.org/rdql/?query="+es);
//  		    if(sort)
//  			parser.callParserURI(tstoreloc+"="+es,svar,sterm);
//  		    else
//  			parser.callParserURI(tstoreloc+"="+es);

//  		    //response = parser.table;
//  		    //rtext.setText("");
//  		    System.out.println((parser.table).getFirstColumnString());
//  		    if(parser.NoMatches) System.out.println("no matches");
//  		    else System.out.println("table generated");
//  		}
//  	    }.start();

//  	}
//  	catch (Exception e){
//  	    System.out.println(e.toString());
//  	}
//      }


    public static void postQuery_ParseXML(String s) {
	final String es;
	final SXML parser = new SXML();

	try{
	    es = URLEncoder.encode(s, "UTF-8");
	    System.out.println("Sent query...waiting for response");
	    //(new SXML()).callParser("x.xml");
	    
	    // probably don't want this threaded for prolog calls...
	    new Thread(){
		    //SXML parser = new SXML();
		    public void run(){
			//parser.callParserURI("http://triplestore.aktors.org/rdql/?query="+es);
			if(sort)
			    parser.callParserURI(tstoreloc+"="+es,svar,sterm);
			else
			    parser.callParserURI(tstoreloc+"="+es);
		       
			//System.out.println((parser.table).toString());
			queryResponse.setTrue();
			//			queryResponse.setValue((parser.table).getFirstColumnString());
			queryResponse.setValueSize((parser.table).size());
			queryResponse.setValue((parser.table).getFirstTwoColumnsString());

		    }
		}.start();

	}
	catch (Exception e){
	    System.out.println(e.toString());
	}
    }

    public static void postQuery_ParseXML2(String s) {
	final String es;
	final SXML parser = new SXML();

	try{
	    es = URLEncoder.encode(s, "UTF-8");
	    System.out.println("Sent query...waiting for response");
	    //(new SXML()).callParser("x.xml");
	    
	    // probably don't want this threaded for prolog calls...
	    new Thread(){
		    //SXML parser = new SXML();
		    public void run(){
			//parser.callParserURI("http://triplestore.aktors.org/rdql/?query="+es);
			if(sort)
			    parser.callParserURI(tstoreloc+"="+es,svar,sterm);
			else
			    parser.callParserURI(tstoreloc+"="+es);
		       
			//System.out.println((parser.table).toString());
			queryResponse.setTrue();
			//			queryResponse.setValue((parser.table).getFirstColumnString());
			//queryResponse.setValueSize((parser.table).size());
			queryResponse.appendUniqueVValue((parser.table).conflateFirstTwoColumns());

		    }
		}.start();

	}
	catch (Exception e){
	    System.out.println(e.toString());
	}
    }

    public static void postYearQuery_ParseXML(String s, final int year) {
	final String es;
	final SXML parser = new SXML();

	try{
	    es = URLEncoder.encode(s, "UTF-8");
	    //System.out.println(s);
	    System.out.println("Sent query...waiting for response");
	    //(new SXML()).callParser("x.xml");
	    
	    // probably don't want this threaded for prolog calls...
	    new Thread(){
		    //SXML parser = new SXML();
		    public void run(){
			//parser.callParserURI("http://triplestore.aktors.org/rdql/?query="+es);
			if(sort)
			    parser.callParserURI(tstoreloc+"="+es,svar,sterm);
			else
			    parser.callParserURI(tstoreloc+"="+es);
		       
			//System.out.println((parser.table).toString());
			queryResponse.setTrue();
			//queryResponse.setValue((parser.table).getFirstColumnString());
			queryResponse.setValueSize((parser.table).size());
			queryResponse.setValue((parser.table).getFirstColumnStringYear(year));
			//queryResponse.setValue((parser.table).getFirstTwoColumnsString());

		    }
		}.start();

	}
	catch (Exception e){
	    System.out.println(e.toString());
	}
    }

    public static void postYearQuery_ParseXML2(String s, final int year) {
	final String es;
	final SXML parser = new SXML();

	try{
	    es = URLEncoder.encode(s, "UTF-8");
	    //System.out.println(s);
	    System.out.println("Sent query...waiting for response");
	    //(new SXML()).callParser("x.xml");
	    
	    new Thread(){
		    //SXML parser = new SXML();
		    public void run(){
			//parser.callParserURI("http://triplestore.aktors.org/rdql/?query="+es);
			if(sort)
			    parser.callParserURI(tstoreloc+"="+es,svar,sterm);
			else
			    parser.callParserURI(tstoreloc+"="+es);
		       
			queryResponse.setTrue();
			queryResponse.appendUniqueVValue((parser.table).getFirstColumnYear(year));
		    }
		}.start();

	}
	catch (Exception e){
	    System.out.println(e.toString());
	}
    }





    /**
     * Sleeps for the specified number of seconds.
     * Shamelessly looted from Jeff's ix.util.Util class!
     */
    public static void sleepSeconds(int seconds) {
	if (seconds > 0) {
	    int delay = seconds * 1000;
	    //System.out.println("Sleeping "+seconds+" seconds");
	    try { Thread.sleep(delay); }
	    catch (InterruptedException e) {}
	}
    }

    public static String identifySteeringCommittee(String itopic){

	String rae5s = "rae-5*";
	String rae5 = "rae-5";

	String topic = itopic.toUpperCase(); // just in case

	System.out.println("Topic = "+ topic);

	//String RDQL = "SELECT ?pname WHERE (?inst, <akt:contributes-to-rating>, ?rating),(?rating, <akt:has-research-quality>, <akt:rae-5*>), (?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+ topic + "\"), (?inst, <http://www.aktors.org/ontology/support#has-pretty-name>, ?name), (?inst, <akt:unit-of-organization>, ?unit), (?unit, <http://www.aktors.org/ontology/support#has-pretty-name>, ?uname), (?person, <akt:works-in-unit>, ?inst), (?person, <http://www.aktors.org/ontology/support#has-pretty-name>, ?pname) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>";
		

	String RDQL = "SELECT ?pperson, ?email WHERE (?inst, <akt:contributes-to-rating>, ?rating),(?rating, <akt:has-research-quality>, <akt:rae-5*>),(?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?person, <akt:has-appellation>, \"Professor\"),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";

	queryResponse.setFalse();
	postQuery_ParseXML(RDQL);
	System.out.println("about to wait until true...");
	queryResponse.waitUntilTrue(timeout*1000);
	String result = "no matches";
	if(queryResponse.isTrue()){
	    sleepSeconds(2);
	    result = (String) queryResponse.getValue();
	    int rsize = queryResponse.getValueSize();
	    
	    //if(result.equalsIgnoreCase("[]")||result.equalsIgnoreCase("")||rsize<4){
	    if(rsize<4){
		System.out.println("not enough matches ("+rsize+"): generalising query");
		
		//		RDQL = "SELECT ?pperson, ?email WHERE (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:has-research-interest>, ?topic),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?person, <akt:has-appellation>, \"Professor\"),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
		RDQL = "SELECT ?pperson, ?email WHERE  (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:has-research-interest>, ?topic),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
	    	queryResponse.setFalse();
		postQuery_ParseXML(RDQL);
		System.out.println("about to wait until true (2)...");
		queryResponse.waitUntilTrue(timeout*1000);
		//result = "no matches";
		if(queryResponse.isTrue()){
		    sleepSeconds(2);
		    result = (String) queryResponse.getValue();
		    if(result.equalsIgnoreCase("[]")||result.equalsIgnoreCase(""))
			result = "no matches";
		}
	    }
	}

	return result;

	//	    return "no matches";
	//return postQuery_ParseXML(RDQL);
	
    }

    public static String identifySteeringCommittee2(String itopic){

	String topic = itopic.toUpperCase(); // just in case
	System.out.println("Topic = "+ topic);
	String RDQL;

	queryResponse.reset();

	for(int i=0;i<8;i++){

	    RDQL = "SELECT ?pperson, ?email WHERE (?inst, <akt:contributes-to-rating>, ?rating),(?rating, <akt:has-research-quality>, <akt:rae-5*>),(?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?person, <akt:has-appellation>, \"Professor\"),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \""+ epsrctopics[i] + "\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";

	    queryResponse.setFalse();
	    postQuery_ParseXML2(RDQL);
	    System.out.println("about to wait until true...");
	    queryResponse.waitUntilTrue(timeout*1000);
	}

	int rsize = queryResponse.getVValueSize();

	if(rsize<4){
	    System.out.println("not enough matches ("+rsize+"): generalising query");
	    
	    for(int i=0;i<8;i++){

		RDQL = "SELECT ?pperson, ?email WHERE  (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:has-research-interest>, ?topic),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \""+ epsrctopics[i] + "\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
		queryResponse.setFalse();
		postQuery_ParseXML2(RDQL);
		System.out.println("about to wait until true (2)...");
		queryResponse.waitUntilTrue(timeout*1000);
	    }
	}
    
	return ((String) queryResponse.getVValue(10));
    }


    public static String identifyLiveIssues2(String itopic){

	String topic = itopic.toUpperCase(); // just in case
	System.out.println("Topic = "+ topic);
	String RDQL;

	int yearcutoff = (Calendar.getInstance()).get(Calendar.YEAR);
	System.out.println("And this year is "+yearcutoff);

	queryResponse.reset();

	for(int i=0;i<8;i++){

	    //RDQL = "SELECT ?pproj, ?year WHERE (?inst, <akt:contributes-to-rating>, ?rating), (?rating, <akt:has-research-quality>, <akt:rae-5*>), (?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+topic+"\"),(?inst, <akt:unit-of-organization>, ?uni),(?proj, <akt:addresses-generic-area-of-interest>, ?gai), (?gai, <sup:has-pretty-name>, \""+ epsrctopics[i] + "\"),(?proj, <sup:has-pretty-name>, ?pproj),(?proj, <sup:has-time-interval>, ?inter),(?inter, <sup:ends-at-time-point>, ?etp),(?etp, <sup:year-of>, ?year),(?proj, <akt:has-project-member>, ?person), (?person, <akt:works-for>, ?uni) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
	    RDQL = "SELECT ?pproj, ?year WHERE (?inst, <akt:contributes-to-rating>, ?rating), (?rating, <akt:has-research-quality>, <akt:rae-5*>), (?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+topic+"\"),(?inst, <akt:unit-of-organization>, ?uni),(?proj, <akt:addresses-generic-area-of-interest>, ?gai), (?gai, <sup:has-pretty-name>, \""+ epsrctopics[i] + "\"),(?proj, <akt:has-leading-organization>, ?uni),(?proj, <sup:has-pretty-name>, ?pproj),(?proj, <sup:has-time-interval>, ?inter),(?inter, <sup:ends-at-time-point>, ?etp),(?etp, <sup:year-of>, ?year) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
	    //RDQL = "SELECT ?pproj, ?year, ?pvalue WHERE (?inst, <akt:contributes-to-rating>, ?rating), (?rating, <akt:has-research-quality>, <akt:rae-5*>), (?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+topic+"\"),(?inst, <akt:unit-of-organization>, ?uni),(?proj, <akt:addresses-generic-area-of-interest>, ?gai), (?gai, <sup:has-pretty-name>, \""+ epsrctopics[i] + "\"),(?proj, <sup:has-pretty-name>, ?pproj),(?proj, <akt:has-funding>, ?funding),(?funding, <akt:has-grant-value>, ?value),(?value, <akt:has-amount>, ?pvalue),(?proj, <sup:has-time-interval>, ?inter),(?inter, <sup:ends-at-time-point>, ?etp),(?etp, <sup:year-of>, ?year),(?proj, <akt:has-leading-organization>, ?uni) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
	    queryResponse.setFalse();
	    postYearQuery_ParseXML2(RDQL, yearcutoff);
	    System.out.println("about to wait until true...");
	    queryResponse.waitUntilTrue(timeout*1000);
	}

	int rsize = queryResponse.getVValueSize();

	if(rsize<4){
  	    System.out.println("not enough matches ("+rsize+"): generalising query");
	    
  	    for(int i=0;i<8;i++){
		RDQL = "SELECT ?pproj, ?year WHERE (?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+topic+"\"),(?inst, <akt:unit-of-organization>, ?uni),(?proj, <akt:addresses-generic-area-of-interest>, ?gai), (?gai, <sup:has-pretty-name>, \""+ epsrctopics[i] + "\"),(?proj, <akt:has-leading-organization>, ?uni),(?proj, <sup:has-pretty-name>, ?pproj),(?proj, <sup:has-time-interval>, ?inter),(?inter, <sup:ends-at-time-point>, ?etp),(?etp, <sup:year-of>, ?year) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";


  		queryResponse.setFalse();
  		postYearQuery_ParseXML2(RDQL, yearcutoff);
  		System.out.println("about to wait until true (2)...");
  		queryResponse.waitUntilTrue(timeout*1000);
  	    }
  	}
    
	return ((String) queryResponse.getVValue(10));
    }



    public static String identifyLiveIssues(String itopic){

	String rae5s = "rae-5*";
	String rae5 = "rae-5";

	String topic = itopic.toUpperCase(); // just in case

	System.out.println("Topic = "+ topic);



	//	String RDQL = "SELECT ?pproj, ?year WHERE (?proj, <akt:addresses-generic-area-of-interest>, ?gai), (?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?proj, <sup:has-pretty-name>, ?pproj),(?proj, <sup:has-time-interval>, ?inter),(?inter, <sup:ends-at-time-point>, ?etp),(?etp, <sup:year-of>, ?year) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";

	String RDQL = "SELECT ?pproj, ?year WHERE (?inst, <akt:contributes-to-rating>, ?rating), (?rating, <akt:has-research-quality>, <akt:rae-5*>), (?inst, <akt:has-research-interest>, ?topic), (?topic, <rdfs:label>, \""+topic+"\"),(?inst, <akt:unit-of-organization>, ?uni),(?proj, <akt:addresses-generic-area-of-interest>, ?gai), (?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?proj, <sup:has-pretty-name>, ?pproj),(?proj, <sup:has-time-interval>, ?inter),(?inter, <sup:ends-at-time-point>, ?etp),(?etp, <sup:year-of>, ?year),(?proj, <akt:has-project-member>, ?person), (?person, <akt:works-for>, ?uni) USING owl FOR <http://www.w3.org/2002/07/owl#>, akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";

	queryResponse.setFalse();
	postYearQuery_ParseXML(RDQL,2003);
	System.out.println("about to wait until true...");
	queryResponse.waitUntilTrue(timeout*1000);
	String result = "no matches";
	if(queryResponse.isTrue()){
	    sleepSeconds(2);
	    result = (String) queryResponse.getValue();
	    int rsize = queryResponse.getValueSize();
	    if(rsize<1)
		System.out.println("not enough matches ("+rsize+")!");



	    //if(result.equalsIgnoreCase("[]")||result.equalsIgnoreCase("")||rsize<4){
		//if(rsize<4){
		//System.out.println("not enough matches ("+rsize+"): generalising query");
	    
		//		RDQL = "SELECT ?pperson, ?email WHERE (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:has-research-interest>, ?topic),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?person, <akt:has-appellation>, \"Professor\"),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
		//RDQL = "SELECT ?pperson, ?email WHERE  (?topic, <rdfs:label>, \""+ topic + "\"),(?inst, <akt:has-research-interest>, ?topic),(?inst, <akt:unit-of-organization>, ?uni),(?person, <akt:works-for>, ?uni),(?proj, <akt:has-project-leader>, ?person),(?proj, <akt:addresses-generic-area-of-interest>, ?gai),(?gai, <sup:has-pretty-name>, \"Information and Knowledge Management\"),(?person, <sup:has-pretty-name>, ?pperson),(?person, <akt:has-email-address>, ?email) USING owl FOR <http://www.w3.org/2002/07/owl#>,akt FOR <http://www.aktors.org/ontology/portal#>, rdfs FOR <http://www.w3.org/2000/01/rdf-schema#>, sup FOR <http://www.aktors.org/ontology/support#>";
	    	//queryResponse.setFalse();
		//postQuery_ParseXML(RDQL);
		//System.out.println("about to wait until true (2)...");
		//queryResponse.waitUntilTrue(timeout*1000);
		//result = "no matches";
		//if(queryResponse.isTrue()){
		//  sleepSeconds(2);
		//  result = (String) queryResponse.getValue();
		//  if(result.equalsIgnoreCase("[]")||result.equalsIgnoreCase(""))
		//result = "no matches";
		//}
		//}
		//}
	}

	return result;
	
    }


    public static void getNBestPeople(int N, String topic, StringBuffer response){
	// heuristic to return the N 'best' people in subject area topic;
	// these are 'unified' with the StringBuffer reponse...
	sort = true;
	svar = "name";
	sterm = topic;

	String RDQL = "SELECT ?name, ?uri, ?ri  WHERE (?uri, <http://www.aktors.org/ontology/portal#has-research-interest>, ?ri), (?ri,<http://www.w3.org/1999/02/22-rdf-syntax-ns#type>,<http://www.acm.org/class/1998/Research-Area>), (?ri,<http://www.aktors.org/ontology/portal#sub-area-of>,<http://www.acm.org/class/1998/D>), (?uri, <http://www.aktors.org/ontology/portal#has-pretty-name>, ?name)";
	//return "yes";

    }

    public static void getBestPeople(int N, String topic, StringBuffer response){
	System.out.println("Request for best "+N+" people interested in "+topic);
	response.append("[stuart, jessica]");
    }

public static void main(String[] argv) {	
	if(argv.length>=1){
	    tstoreloc = argv[0];
	    System.out.println("3Store address: "+tstoreloc);
	}

	//postQuery_ParseXML("SELECT ?name, ?uri, ?ri  WHERE (?uri, <http://www.aktors.org/ontology/portal#has-research-interest>, ?ri), (?ri,<http://www.w3.org/1999/02/22-rdf-syntax-ns#type>,<http://www.acm.org/class/1998/Research-Area>), (?ri,<http://www.aktors.org/ontology/portal#sub-area-of>,<http://www.acm.org/class/1998/D>), (?uri, <http://www.aktors.org/ontology/portal#has-pretty-name>, ?name)");
}

}


/*

SELECT ?name, ?uri, ?ri  WHERE 
(?uri, <http://www.aktors.org/ontology/portal#has-research-interest>, ?ri),
(?ri,<http://www.w3.org/1999/02/22-rdf-syntax-ns#type>,<http://www.acm.org/class/1998/Research-Area>),
(?ri,<http://www.aktors.org/ontology/portal#sub-area-of>,<http://www.acm.org/class/1998/D>),
(?uri, <http://www.aktors.org/ontology/portal#has-pretty-name>, ?name)

 */
