
import java.io.*;

//  import org.jdom.Element;
//  import org.jdom.Document;
//  import org.jdom.JDOMException;
//  import org.jdom.input.SAXBuilder;
//  import org.jdom.output.XMLOutputter;

//import org.apache.xerces.parsers.*;

import org.w3c.dom.*;
import java.util.*;
import java.net.*;

import ix.util.xml.XML;
import ix.util.Strings;
import ix.util.ThreadCondition;
import ix.icore.IXAgent;
import ix.util.*;
import ix.ichat.ChatMessage;
import ix.iface.util.ToolController;
import ix.iquery.*;
import ix.icore.*;
import ix.util.lisp.LList;

//  import org.jabber.jabberbeans.*;
//  import org.jabber.jabberbeans.Extension.*;
//  import org.jabber.jabberbeans.serverside.*;
//  import org.jabber.jabberbeans.util.*;

import java.awt.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;

import Basic3SV.*;


public class TripleStoreAgent extends IQuery {

     public TripleStoreAgent() {
         super();
     }

     public static void main(String[] argv) {
         Util.printGreeting("I-Q TripleStoreAgent");
         new TripleStoreAgent().mainStartup(argv);
     }

     protected boolean isLookupActivity(Activity activity) {
	 // return activity.getPattern().get(0) == ...;
	 //return true;
	 String verb = (activity.getVerb()).toString();
	 return(verb.equalsIgnoreCase("identify-steering-committee") ||
		verb.equalsIgnoreCase("identify-live-issues"));
		
	 //return (activity.getPattern().get(0).toString().equals("identify-steering-committee") ||
	 //	 activity.getPattern().get(0).toString().equals("identify-live-issues"));
     }


     protected LookupHandler
               makeLookupHandler(IQuery queryAgent,
                                 Activity lookupActivity) {
         return new TripleStoreAgentLookupHandler(queryAgent, lookupActivity);
     }

//      protected void startup(){
//  	Debug.noteln("no gui!");
//      }

    // protected void handleLookupActivity(Activity activity){
    //}

     static class TripleStoreAgentLookupHandler extends LookupHandler {

         TripleStoreAgentLookupHandler(IQuery agent, Activity activity) {
             super(agent, activity);
         }

         protected void handleLookup() {
             try {
                 //...
		 // sendReport(ReportType.SUCCESS, "Finished -- ...");
		sendReport(ReportType.PROGRESS, "Started " + lookupActivity);
		String capability = (lookupActivity.getVerb()).toString();

		String topic ="";
		LList params = lookupActivity.getParameters();
		for(int i=0;i<params.size();i++){
		    topic += (params.elementAt(i)).toString();
		    if(i<(params.size()-1)) topic +=" ";
		}

		//		String topic = ((lookupActivity.getParameters()).car()).toString();
		String result = "unavailable capability";

		//Debug.noteln("activity-verb:"+ (lookupActivity.getVerb()).toString());
		Debug.noteln("activity-params:"+ ((lookupActivity.getParameters())).toString());
		if(capability.equalsIgnoreCase("identify-steering-committee")){
		    Debug.noteln("called identify-steering-committee with "+topic);
		    result = TripleViewer.identifySteeringCommittee2(topic);
		}
		else if(capability.equalsIgnoreCase("identify-live-issues")){
		    Debug.noteln("called identify-live-issues with "+topic);
		    result = TripleViewer.identifyLiveIssues2(topic);
		}
		
		//Util.sleepSeconds(3);
		//                sendReport(ReportType.SUCCESS, "Finished " + lookupActivity+ ":"+result);
                sendReport(ReportType.SUCCESS, "Results: " + result);

             }
             catch (Exception e) {
                 Debug.displayException(e);
                 sendReport(ReportType.FAILURE,
                            "Problem: " + Debug.describeException(e));
             }
         }

     }

 }




