package Basic3SV;

import java.util.Vector;
import java.util.Hashtable;

public class Row extends Object {
    public Vector content;
    public Hashtable htable;
    public double score;

    public Row(int y) {
	content = new Vector(y);
	htable = null;
	score = -1;
    }

    public Row() {
	content = new Vector();
	htable = null;
	score = -1;
    }

    public void addElement(Element e) {
	content.addElement(e);
    }

    public void setValue(Element e,int y) {
	if(y<content.size())
	    content.setElementAt(e,y);
    }

    public Element getValue(int y) {
	if(y<content.size())
	    return (Element)content.elementAt(y);
	return null;
    }

    public int getY() {
	return content.size()-1;
    }

    public String toString() {
	String s = "";
	Double d = new Double(score);
	for(int i=0;i<content.size();++i) 
	    s=s+((Element)content.elementAt(i)).toString()+" "+d.toString();
	return s;
    }

    public Vector getContent(){
	//return content;
	Vector rc = new Vector();
	for(int i=0;i<content.size();i++){
	    rc.add(((Element) (content.elementAt(i))).getValue());
	}
	return rc;
    }

    public Vector getContentAndScore(){
	//return content;
	Vector rc = new Vector();
	for(int i=0;i<content.size();i++){
	    rc.add(((Element) (content.elementAt(i))).getValue());
	}
	rc.add((new Double(score)).toString());
	return rc;
    }
}

